openapi: 3.0.0
paths:
  /api/settings:
    get:
      operationId: ConfigController_getSettings
      summary: Retrieve settings
      description: Retrieves the settings of the control plane.
      parameters: []
      responses:
        "200":
          description: ""
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/RuntimeConfigDto"
        "403":
          description: Forbidden
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ErrorDto"
      tags: &a1
        - Settings
      security: &a2
        - oauth2:
            - controlplane_admin
  /api/settings/update:
    post:
      operationId: ConfigController_updateSettings
      summary: Update settings
      description: Updates runtime settings for the control plane.
      parameters: []
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: "#/components/schemas/RuntimeConfigDto"
      responses:
        "200":
          description: ""
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/RuntimeConfigDto"
        "400":
          description: Malformed request
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ErrorDto"
        "403":
          description: Forbidden
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ErrorDto"
      tags: *a1
      security: *a2
  /health:
    get:
      operationId: HealthController_getHealth
      summary: Health check
      description:
        Retrieves the current health of the control plane. If the control
        plane is running it always returns an empty 200 OK
      parameters: []
      responses:
        "200":
          description: ""
        "502":
          description: ""
      tags:
        - Health
  /api/auth/user:
    get:
      operationId: AuthController_getUser
      summary: Retrieve current user status
      description:
        Retrieves current user state, whether someone is logged in or not a
        200 result is provided. This is used in the frontend to determine
        whether certain aspects should be shown.
      parameters: []
      responses:
        "200":
          description: ""
          content:
            application/json:
              schema:
                oneOf:
                  - $ref: "#/components/schemas/AuthenticatedUserDto"
                  - $ref: "#/components/schemas/UnauthenticatedUserDto"
      tags: &a3
        - Authentication
  /api/auth/login:
    get:
      operationId: AuthController_login
      summary: Login redirect
      description: Redirects user to the correct authorization server
      parameters: []
      responses:
        "200":
          description: ""
      tags: *a3
  /api/auth/logout:
    get:
      operationId: AuthController_logout
      summary: Logout redirect
      description:
        Removes session information and redirects user the root of the
        frontend (`auth.redirectURL`)
      parameters: []
      responses:
        "302":
          description: ""
      tags: *a3
  /api/auth/callback:
    get:
      operationId: AuthController_callback
      summary: Login callback
      description:
        Users are redirected from the authorization server to this endpoint
        which will redirect them to the frontend (`auth.redirectURL`)
      parameters: []
      responses:
        "302":
          description: ""
      tags: *a3
  /api/data-plane/init:
    post:
      operationId: DataPlaneController_init
      summary: Initialize data plane
      description: Initializes a new data plane with the provided details.
      parameters: []
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: "#/components/schemas/DataPlaneCreationDto"
      responses:
        "200":
          description: ""
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/DataPlaneDto"
        "400":
          description: Invalid data plane details provided
        "403":
          description: Forbidden
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ErrorDto"
      tags: &a4
        - Data Plane
      security: &a5
        - oauth2:
            - controlplane_admin
            - controlplane_dataplane
  /api/data-plane/{id}/update:
    post:
      operationId: DataPlaneController_update
      summary: Update data plane
      description: Updates the details of an existing data plane.
      parameters:
        - name: id
          required: true
          in: path
          schema:
            type: string
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: "#/components/schemas/DataPlaneDto"
      responses:
        "200":
          description: ""
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/DataPlaneDto"
        "400":
          description: Identifier mismatch or invalid data
        "403":
          description: Forbidden
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ErrorDto"
      tags: *a4
      security: *a5
  /api/data-plane/{id}/catalog:
    post:
      operationId: DataPlaneController_updateCatalog
      summary: Update catalog
      description: Updates the catalog for the specified data plane.
      parameters:
        - name: id
          required: true
          in: path
          schema:
            type: string
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: "#/components/schemas/CatalogSchema"
      responses:
        "200":
          description: ""
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/CatalogSchema"
        "400":
          description: Invalid catalog data
        "403":
          description: Forbidden
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ErrorDto"
      tags: *a4
      security: *a5
  /api/management/dataplanes:
    get:
      operationId: DataplaneManagementController_getDataPlanes
      summary: Get all dataplanes
      description: Fetches all the dataplanes.
      parameters: []
      responses:
        "200":
          description: ""
          content:
            application/json:
              schema:
                type: array
                items:
                  $ref: "#/components/schemas/DataPlaneDto"
        "403":
          description: Forbidden
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ErrorDto"
      tags: &a6
        - Data Plane Management
      security: &a7
        - oauth2:
            - controlplane_admin
            - controlplane_dataplane
    post:
      operationId: DataplaneManagementController_addDataplane
      summary: Add a dataplane
      description: Adds a new dataplane.
      parameters: []
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: "#/components/schemas/DataPlaneDto"
      responses:
        "201":
          description: ""
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/DataPlaneDto"
        "400":
          description: Invalid dataplane data
        "403":
          description: Forbidden
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ErrorDto"
      tags: *a6
      security: *a7
  /api/management/dataplanes/{id}:
    put:
      operationId: DataplaneManagementController_updateDataplane
      summary: Update a dataplane
      description: Updates an existing dataplane.
      parameters:
        - name: id
          required: true
          in: path
          schema:
            type: string
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: "#/components/schemas/DataPlaneDto"
      responses:
        "200":
          description: ""
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/DataPlaneDto"
        "400":
          description: Invalid dataplane data
        "403":
          description: Forbidden
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ErrorDto"
      tags: *a6
      security: *a7
    delete:
      operationId: DataplaneManagementController_deleteDataPlane
      summary: Delete a dataplane
      description: Deletes a dataplane by ID.
      parameters:
        - name: id
          required: true
          in: path
          schema:
            type: string
      responses:
        "202":
          description: Dataplane deleted successfully
        "400":
          description: Invalid dataplane ID
        "403":
          description: Forbidden
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ErrorDto"
      tags: *a6
      security: *a7
  /api/catalog/request:
    post:
      operationId: CatalogController_request
      summary: Request catalog
      description: Requests a catalog with the provided details.
      parameters: []
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: "#/components/schemas/CatalogRequestMessageSchema"
      responses:
        "200":
          description: ""
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/CatalogSchema"
        "400":
          description: Invalid catalog request data
        "403":
          description: Forbidden
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ErrorDto"
      tags: &a8
        - Catalog
      security: &a9
        - bearer: []
  /api/catalog/datasets/{id}:
    get:
      operationId: CatalogController_getDataset
      summary: Get dataset
      description: Fetches a dataset by ID.
      parameters:
        - name: id
          required: true
          in: path
          schema:
            type: string
      responses:
        "200":
          description: ""
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/DatasetSchema"
        "400":
          description: Invalid dataset ID
        "403":
          description: Forbidden
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ErrorDto"
      tags: *a8
      security: *a9
  /api/management/catalog/request:
    get:
      operationId: CatalogManagementController_requestCatalog
      summary: Request catalog
      description: Requests a catalog from a remote or local connector.
      parameters:
        - name: address
          required: false
          in: query
          description: The address of the remote connector
          schema:
            type: string
        - name: audience
          required: false
          in: query
          description: The audience for the request
          schema:
            type: string
      responses:
        "200":
          description: ""
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/CatalogSchema"
        "400":
          description: Invalid request parameters
        "403":
          description: Forbidden
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ErrorDto"
      tags: &a10
        - Catalog Management
      security: &a11
        - bearer: []
  /api/management/catalog/dataset:
    get:
      operationId: CatalogManagementController_requestDataset
      summary: Request dataset
      description: Requests a dataset from a remote or local connector by ID.
      parameters:
        - name: address
          required: false
          in: query
          description: The address of the remote connector
          schema:
            type: string
        - name: id
          required: true
          in: query
          description: The ID of the dataset
          schema:
            type: string
        - name: audience
          required: false
          in: query
          description: The audience for the request
          schema:
            type: string
      responses:
        "200":
          description: ""
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/DatasetSchema"
        "400":
          description: Invalid request parameters
        "403":
          description: Forbidden
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ErrorDto"
      tags: *a10
      security: *a11
    post:
      operationId: CatalogManagementController_addDataset
      summary: Add dataset
      description: Adds a new dataset to the catalog.
      parameters: []
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: "#/components/schemas/DatasetSchema"
      responses:
        "201":
          description: ""
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/DatasetSchema"
        "400":
          description: Invalid dataset data
        "403":
          description: Forbidden
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ErrorDto"
      tags: *a10
      security: *a11
  /api/management/catalog/dataset/{id}:
    put:
      operationId: CatalogManagementController_updateDataset
      summary: Update dataset
      description: Updates an existing dataset in the catalog.
      parameters:
        - name: id
          required: true
          in: path
          description: The ID of the dataset to update
          schema:
            type: string
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: "#/components/schemas/DatasetSchema"
      responses:
        "202":
          description: ""
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/DatasetSchema"
        "400":
          description: Invalid dataset data
        "403":
          description: Forbidden
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ErrorDto"
      tags: *a10
      security: *a11
    delete:
      operationId: CatalogManagementController_deleteDataset
      summary: Delete dataset
      description: Deletes a dataset from the catalog by ID.
      parameters:
        - name: id
          required: true
          in: path
          description: The ID of the dataset to delete
          schema:
            type: string
      responses:
        "204":
          description: Dataset deleted successfully
        "400":
          description: Invalid dataset ID
        "403":
          description: Forbidden
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ErrorDto"
      tags: *a10
      security: *a11
  /api/negotiations/request:
    post:
      operationId: NegotiationController_request
      summary: Request a new negotiation
      parameters: []
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: "#/components/schemas/ContractRequestMessageSchema"
      responses:
        "201":
          description: ""
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ContractNegotiationSchema"
      tags: &a12
        - Negotiations
      security: &a13
        - bearer: []
  /api/negotiations/{id}:
    get:
      operationId: NegotiationController_getNegotiation
      summary: Get negotiation status by ID
      parameters:
        - name: id
          required: true
          in: path
          schema:
            type: string
      responses:
        "200":
          description: ""
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ContractNegotiationSchema"
      tags: *a12
      security: *a13
  /api/negotiations/{id}/request:
    post:
      operationId: NegotiationController_requestWithId
      summary: Request negotiation with ID
      parameters:
        - name: id
          required: true
          in: path
          schema:
            type: string
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: "#/components/schemas/ContractRequestMessageSchema"
      responses:
        "200":
          description: ""
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ContractNegotiationSchema"
      tags: *a12
      security: *a13
  /api/negotiations/{id}/events:
    post:
      operationId: NegotiationController_negotiationEvent
      summary: Handle negotiation event
      parameters:
        - name: id
          required: true
          in: path
          schema:
            type: string
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: "#/components/schemas/ContractNegotiationEventMessageSchema"
      responses:
        "200":
          description: ""
          content:
            application/json:
              schema:
                example:
                  status: string
      tags: *a12
      security: *a13
  /api/negotiations/{id}/agreement/verification:
    post:
      operationId: NegotiationController_agreementVerification
      summary: Verify agreement
      parameters:
        - name: id
          required: true
          in: path
          schema:
            type: string
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: "#/components/schemas/ContractAgreementVerificationMessageSchema"
      responses:
        "200":
          description: ""
          content:
            application/json:
              schema:
                example:
                  status: string
      tags: *a12
      security: *a13
  /api/negotiations/{id}/termination:
    post:
      operationId: NegotiationController_negotiationTermination
      summary: Terminate negotiation
      parameters:
        - name: id
          required: true
          in: path
          schema:
            type: string
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: "#/components/schemas/ContractNegotiationTerminationMessageSchema"
      responses:
        "200":
          description: ""
          content:
            application/json:
              schema:
                example:
                  status: string
      tags: *a12
      security: *a13
  /api/negotiations/callbacks/{id}/offer:
    post:
      operationId: NegotiationController_callbackOffer
      summary: Handle negotiation callback offer
      parameters:
        - name: id
          required: true
          in: path
          schema:
            type: string
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: "#/components/schemas/ContractOfferMessageSchema"
      responses:
        "201":
          description: ""
          content:
            application/json:
              schema:
                example:
                  status: string
      tags: *a12
      security: *a13
  /api/negotiations/callbacks/{id}/agreement:
    post:
      operationId: NegotiationController_callbackAgreement
      summary: Handle negotiation callback agreement
      parameters:
        - name: id
          required: true
          in: path
          schema:
            type: string
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: "#/components/schemas/ContractAgreementMessageSchema"
      responses:
        "201":
          description: ""
          content:
            application/json:
              schema:
                example:
                  status: string
      tags: *a12
      security: *a13
  /api/negotiations/callbacks/{id}/events:
    post:
      operationId: NegotiationController_callbackEvent
      summary: Handle negotiation callback event
      parameters:
        - name: id
          required: true
          in: path
          schema:
            type: string
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: "#/components/schemas/ContractNegotiationEventMessageSchema"
      responses:
        "201":
          description: ""
          content:
            application/json:
              schema:
                example:
                  status: string
      tags: *a12
      security: *a13
  /api/management/negotiations:
    get:
      operationId: NegotiationManagementController_getNegotiations
      summary: Get all negotiations
      parameters: []
      responses:
        "200":
          description: Successfully fetched negotiations
          content:
            application/json:
              schema:
                type: array
                items:
                  $ref: "#/components/schemas/NegotiationStatusDto"
      tags: &a14
        - Negotiations Management
      security: &a15
        - oauth2:
            - controlplane_admin
            - controlplane_dataplane
  /api/management/negotiations/{processId}:
    get:
      operationId: NegotiationManagementController_getNegotiation
      summary: Get a negotiation by process ID
      parameters:
        - name: processId
          required: true
          in: path
          description: Process ID of the negotiation
          schema:
            type: string
      responses:
        "200":
          description: Successfully fetched negotiation
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/NegotiationDetailSchema"
      tags: *a14
      security: *a15
  /api/management/negotiations/request:
    post:
      operationId: NegotiationManagementController_requestNewNegotiation
      summary: Request a new negotiation
      parameters:
        - name: dataSet
          required: true
          in: query
          description: Dataset for the negotiation
          schema:
            type: string
        - name: address
          required: true
          in: query
          description: Address for the negotiation
          schema:
            type: string
        - name: audience
          required: true
          in: query
          description: Audience for the negotiation
          schema:
            type: string
      requestBody:
        required: true
        description: Offer details
        content:
          application/json:
            schema:
              $ref: "#/components/schemas/OfferSchema"
      responses:
        "200":
          description: ""
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ContractNegotiationSchema"
      tags: *a14
      security: *a15
  /api/management/negotiations/{processId}/request:
    post:
      operationId: NegotiationManagementController_requestExistingNegotiation
      summary: Request an existing negotiation
      parameters:
        - name: processId
          required: true
          in: path
          description: Process ID of the negotiation
          schema:
            type: string
      requestBody:
        required: true
        description: Offer details
        content:
          application/json:
            schema:
              $ref: "#/components/schemas/OfferSchema"
      responses:
        "200":
          description: ""
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ContractNegotiationSchema"
      tags: *a14
      security: *a15
  /api/management/negotiations/{processId}/offer:
    post:
      operationId: NegotiationManagementController_offer
      summary: Submit an offer for an existing negotiation
      parameters:
        - name: processId
          required: true
          in: path
          description: Process ID of the negotiation
          schema:
            type: string
        - name: address
          required: false
          in: query
          description: Address for the negotiation
          schema:
            type: string
      requestBody:
        required: true
        description: Offer details
        content:
          application/json:
            schema:
              $ref: "#/components/schemas/OfferSchema"
      responses:
        "200":
          description: ""
          content:
            application/json:
              schema:
                example:
                  status: string
      tags: *a14
      security: *a15
  /api/management/negotiations/{processId}/agreement:
    post:
      operationId: NegotiationManagementController_agree
      summary: Agree to a negotiation
      parameters:
        - name: processId
          required: true
          in: path
          description: Process ID of the negotiation
          schema:
            type: string
      responses:
        "200":
          description: ""
          content:
            application/json:
              schema:
                example:
                  status: string
      tags: *a14
      security: *a15
  /api/management/negotiations/{processId}/verify:
    post:
      operationId: NegotiationManagementController_verify
      summary: Verify a negotiation agreement
      parameters:
        - name: processId
          required: true
          in: path
          description: Process ID of the negotiation
          schema:
            type: string
      responses:
        "200":
          description: ""
          content:
            application/json:
              schema:
                example:
                  status: string
      tags: *a14
      security: *a15
  /api/management/negotiations/{processId}/finalize:
    post:
      operationId: NegotiationManagementController_finalize
      summary: Finalize a negotiation
      parameters:
        - name: processId
          required: true
          in: path
          description: Process ID of the negotiation
          schema:
            type: string
      responses:
        "200":
          description: ""
          content:
            application/json:
              schema:
                example:
                  status: string
      tags: *a14
      security: *a15
  /api/management/negotiations/{processId}/terminate:
    post:
      operationId: NegotiationManagementController_terminate
      summary: Terminate a negotiation
      parameters:
        - name: processId
          required: true
          in: path
          description: Process ID of the negotiation
          schema:
            type: string
      requestBody:
        required: true
        description: Termination details
        content:
          application/json:
            schema:
              example:
                code: string
                reason: string
      responses:
        "200":
          description: ""
          content:
            application/json:
              schema:
                example:
                  status: string
      tags: *a14
      security: *a15
  /api/management/agreements/{agreementId}:
    get:
      operationId: AgreementManagementController_getAgreement
      summary: Get an agreement by agreement ID
      parameters:
        - name: agreementId
          required: true
          in: path
          description: Agreement ID
          schema:
            type: string
      responses:
        "200":
          description: ""
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ContractAgreementMessageSchema"
      tags:
        - Agreement
      security:
        - oauth2:
            - controlplane_admin
  /api/management/policy/evaluation/{transferId}/lastContext:
    get:
      operationId: PolicyEvaluationController_getLastContext
      summary: Retrieve last evaluation context
      description: Retrieve last evaluation context of the specified transfer ID.
      parameters:
        - name: transferId
          required: true
          in: path
          schema:
            type: string
      responses:
        "200":
          description: ""
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/EvaluationContext"
        "403":
          description: Forbidden
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ErrorDto"
        "404":
          description: Resource not found
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ErrorDto"
      tags: &a16
        - Evaluation
      security: &a17
        - oauth2:
            - controlplane_admin
  /api/management/policy/evaluation/{transferId}/lastDecision:
    get:
      operationId: PolicyEvaluationController_getLastDecision
      summary: Retrieve last evaluation decision
      description: Retrieve last evaluation decision of the specified transfer ID.
      parameters:
        - name: transferId
          required: true
          in: path
          schema:
            type: string
      responses:
        "200":
          description: ""
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/EvaluationDecision"
        "403":
          description: Forbidden
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ErrorDto"
        "404":
          description: Resource not found
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ErrorDto"
      tags: *a16
      security: *a17
  /api/management/policy/evaluation/{transferId}/evaluate:
    post:
      operationId: PolicyEvaluationController_evaluate
      summary: Retrieve last evaluation context
      description: Retrieve last evaluation context of the specified transfer ID.
      parameters:
        - name: transferId
          required: true
          in: path
          schema:
            type: string
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: "#/components/schemas/EvaluationContext"
      responses:
        "200":
          description: ""
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/EvaluationDecision"
        "403":
          description: Forbidden
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ErrorDto"
        "404":
          description: Resource not found
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ErrorDto"
      tags: *a16
      security: *a17
  /api/management/policy/evaluation/{transferId}/evaluate/data-plane:
    post:
      operationId: PolicyEvaluationController_evaluateDataPlane
      summary: Retrieve last evaluation context
      description: Retrieve last evaluation context of the specified transfer ID.
      parameters:
        - name: transferId
          required: true
          in: path
          schema:
            type: string
      responses:
        "200":
          description: ""
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/EvaluationDecision"
        "403":
          description: Forbidden
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ErrorDto"
        "404":
          description: Resource not found
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ErrorDto"
      tags: *a16
      security: *a17
  /api/management/policy/constraint:
    get:
      operationId: RuleRepositoryController_getConstraints
      summary: Retrieve constraints
      description: Retrieve constraint templates registered in this control plane
      parameters: []
      responses:
        "200":
          description: ""
          content:
            application/json:
              schema:
                type: array
                items:
                  $ref: "#/components/schemas/ConstraintModel"
        "403":
          description: Forbidden
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ErrorDto"
      tags: &a18
        - Evaluation
      security: &a19
        - oauth2:
            - controlplane_admin
    post:
      operationId: RuleRepositoryController_addConstraint
      summary: Add constraint
      description: Add new contraint template
      parameters: []
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: "#/components/schemas/ConstraintModel"
      responses:
        "200":
          description: ""
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ConstraintModel"
        "400":
          description: Malformed request
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ErrorDto"
        "403":
          description: Forbidden
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ErrorDto"
        "409":
          description: Resource already exists
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ErrorDto"
      tags: *a18
      security: *a19
  /api/management/policy/constraint/odrl:
    post:
      operationId: RuleRepositoryController_getConstraintByOdrl
      summary: Get constraint by ODRL
      description: Get constraint based on an ODRL constraint
      parameters: []
      requestBody:
        required: true
        content:
          application/json:
            schema:
              type: string
      responses:
        "200":
          description: ""
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ConstraintModel"
        "403":
          description: Forbidden
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ErrorDto"
        "404":
          description: Resource not found
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ErrorDto"
      tags: *a18
      security: *a19
  /api/management/policy/constraint/{id}:
    get:
      operationId: RuleRepositoryController_getConstraint
      summary: Get constraint
      description: Get constraint based on its identifier
      parameters:
        - name: id
          required: true
          in: path
          schema:
            type: number
      responses:
        "200":
          description: ""
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ConstraintModel"
        "403":
          description: Forbidden
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ErrorDto"
        "404":
          description: Resource not found
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ErrorDto"
      tags: *a18
      security: *a19
    delete:
      operationId: RuleRepositoryController_deleteConstraint
      summary: Delete constraint
      description: Delete constraint template
      parameters:
        - name: id
          required: true
          in: path
          schema:
            type: number
      responses:
        "200":
          description: ""
        "403":
          description: Forbidden
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ErrorDto"
        "404":
          description: Resource not found
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ErrorDto"
      tags: *a18
      security: *a19
    put:
      operationId: RuleRepositoryController_updateConstraint
      summary: Update constraint
      description: Update constraint template
      parameters:
        - name: id
          required: true
          in: path
          schema:
            type: number
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: "#/components/schemas/ConstraintModel"
      responses:
        "200":
          description: ""
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ConstraintModel"
        "400":
          description: Malformed request
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ErrorDto"
        "403":
          description: Forbidden
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ErrorDto"
        "404":
          description: Resource not found
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ErrorDto"
        "409":
          description: Resource already exists
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ErrorDto"
      tags: *a18
      security: *a19
  /api/management/policy/constraint/{id}/odrl:
    get:
      operationId: RuleRepositoryController_getConstraintOdrl
      summary: Get constraint ODRL
      description: Get constraint based on its identifier and convert to ODRL
      parameters:
        - name: id
          required: true
          in: path
          schema:
            type: number
      responses:
        "200":
          description: ""
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ConstraintModel"
        "403":
          description: Forbidden
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ErrorDto"
        "404":
          description: Resource not found
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ErrorDto"
      tags: *a18
      security: *a19
  /api/management/policy/rule:
    get:
      operationId: RuleRepositoryController_getRules
      summary: Retrieve rules
      description: Retrieve rule templates registered in this control plane
      parameters: []
      responses:
        "200":
          description: ""
          content:
            application/json:
              schema:
                type: array
                items:
                  $ref: "#/components/schemas/Rule"
        "403":
          description: Forbidden
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ErrorDto"
      tags: *a18
      security: *a19
    post:
      operationId: RuleRepositoryController_addRule
      summary: Add rule
      description: Add new contraint template
      parameters: []
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: "#/components/schemas/Rule"
      responses:
        "200":
          description: ""
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/Rule"
        "400":
          description: Malformed request
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ErrorDto"
        "403":
          description: Forbidden
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ErrorDto"
        "409":
          description: Resource already exists
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ErrorDto"
      tags: *a18
      security: *a19
  /api/management/policy/rule/{id}:
    get:
      operationId: RuleRepositoryController_getRule
      summary: Get rule
      description: Get rule based on its identifier
      parameters:
        - name: id
          required: true
          in: path
          schema:
            type: number
      responses:
        "200":
          description: ""
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/Rule"
        "403":
          description: Forbidden
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ErrorDto"
        "404":
          description: Resource not found
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ErrorDto"
      tags: *a18
      security: *a19
    delete:
      operationId: RuleRepositoryController_deleteRule
      summary: Delete rule
      description: Delete rule template
      parameters:
        - name: id
          required: true
          in: path
          schema:
            type: number
      responses:
        "200":
          description: ""
        "403":
          description: Forbidden
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ErrorDto"
        "404":
          description: Resource not found
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ErrorDto"
      tags: *a18
      security: *a19
    put:
      operationId: RuleRepositoryController_updateRule
      summary: Update rule
      description: Update rule template
      parameters:
        - name: id
          required: true
          in: path
          schema:
            type: number
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: "#/components/schemas/Rule"
      responses:
        "200":
          description: ""
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/Rule"
        "400":
          description: Malformed request
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ErrorDto"
        "403":
          description: Forbidden
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ErrorDto"
        "404":
          description: Resource not found
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ErrorDto"
        "409":
          description: Resource already exists
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ErrorDto"
      tags: *a18
      security: *a19
  /api/management/policy/rule/{id}/odrl:
    get:
      operationId: RuleRepositoryController_getRuleOdrl
      summary: Get rule ODRL
      description: Get rule ODRL based on its identifier
      parameters:
        - name: id
          required: true
          in: path
          schema:
            type: number
        - name: ruleType
          required: true
          in: path
          schema:
            type: string
        - name: target
          required: true
          in: path
          schema:
            type: string
      responses:
        "200":
          description: ""
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/Rule"
        "403":
          description: Forbidden
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ErrorDto"
        "404":
          description: Resource not found
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ErrorDto"
      tags: *a18
      security: *a19
  /api/transfers/request:
    post:
      operationId: TransferController_request
      summary: Request a transfer
      parameters: []
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: "#/components/schemas/TransferRequestMessageSchema"
      responses:
        "201":
          description: ""
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/TransferProcessSchema"
      tags: &a20
        - Transfers
      security: &a21
        - bearer: []
  /api/transfers/{id}:
    get:
      operationId: TransferController_getTransfer
      summary: Get transfer status by ID
      parameters:
        - name: id
          required: true
          in: path
          description: Transfer ID
          schema:
            type: string
      responses:
        default:
          description: ""
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/TransferProcessSchema"
      tags: *a20
      security: *a21
  /api/transfers/{id}/start:
    post:
      operationId: TransferController_startTransferProcess
      summary: Start transfer process
      parameters:
        - name: id
          required: true
          in: path
          description: Transfer ID
          schema:
            type: string
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: "#/components/schemas/TransferStartMessageSchema"
      responses:
        "200":
          description: Transfer started successfully
          content:
            application/json:
              schema:
                example:
                  status: success
      tags: *a20
      security: *a21
  /api/transfers/{id}/complete:
    post:
      operationId: TransferController_completeTransferProcess
      summary: Complete transfer process
      parameters:
        - name: id
          required: true
          in: path
          description: Transfer ID
          schema:
            type: string
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: "#/components/schemas/TransferCompletionMessageSchema"
      responses:
        "200":
          description: Transfer completed successfully
          content:
            application/json:
              schema:
                example:
                  status: success
      tags: *a20
      security: *a21
  /api/transfers/{id}/terminate:
    post:
      operationId: TransferController_terminateTransferProcess
      summary: Terminate transfer process
      parameters:
        - name: id
          required: true
          in: path
          description: Transfer ID
          schema:
            type: string
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: "#/components/schemas/TransferTerminationMessageSchema"
      responses:
        "200":
          description: Transfer terminated successfully
          content:
            application/json:
              schema:
                example:
                  status: success
      tags: *a20
      security: *a21
  /api/transfers/{id}/suspend:
    post:
      operationId: TransferController_suspendTransferProcess
      summary: Suspend transfer process
      parameters:
        - name: id
          required: true
          in: path
          description: Transfer ID
          schema:
            type: string
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: "#/components/schemas/TransferSuspensionMessageSchema"
      responses:
        "200":
          description: Transfer suspended successfully
          content:
            application/json:
              schema:
                example:
                  status: success
      tags: *a20
      security: *a21
  /api/transfers/callbacks/{id}/start:
    post:
      operationId: TransferController_callbackStartTransferProcess
      summary: Callback to start transfer process
      parameters:
        - name: id
          required: true
          in: path
          description: Transfer ID
          schema:
            type: string
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: "#/components/schemas/TransferStartMessageSchema"
      responses:
        "200":
          description: Callback started transfer successfully
          content:
            application/json:
              schema:
                example:
                  status: success
      tags: *a20
      security: *a21
  /api/transfers/callbacks/{id}/complete:
    post:
      operationId: TransferController_callbackCompleteTransferProcess
      summary: Callback to complete transfer process
      parameters:
        - name: id
          required: true
          in: path
          description: Transfer ID
          schema:
            type: string
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: "#/components/schemas/TransferCompletionMessageSchema"
      responses:
        "200":
          description: Callback completed transfer successfully
          content:
            application/json:
              schema:
                example:
                  status: success
      tags: *a20
      security: *a21
  /api/transfers/callbacks/{id}/terminate:
    post:
      operationId: TransferController_callbackTerminateTransferProcess
      summary: Callback to terminate transfer process
      parameters:
        - name: id
          required: true
          in: path
          description: Transfer ID
          schema:
            type: string
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: "#/components/schemas/TransferTerminationMessageSchema"
      responses:
        "200":
          description: Callback terminated transfer successfully
          content:
            application/json:
              schema:
                example:
                  status: success
      tags: *a20
      security: *a21
  /api/transfers/callbacks/{id}/suspend:
    post:
      operationId: TransferController_callbackSuspendTransferProcess
      summary: Callback to suspend transfer process
      parameters:
        - name: id
          required: true
          in: path
          description: Transfer ID
          schema:
            type: string
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: "#/components/schemas/TransferSuspensionMessageSchema"
      responses:
        "200":
          description: Callback suspended transfer successfully
          content:
            application/json:
              schema:
                example:
                  status: success
      tags: *a20
      security: *a21
  /api/management/transfers:
    get:
      operationId: TransferManagementController_getTransfers
      summary: Get all transfers
      parameters: []
      responses:
        "200":
          description: ""
          content:
            application/json:
              schema:
                type: array
                items:
                  $ref: "#/components/schemas/TransferStatusDto"
      tags: &a22
        - Transfers Management
      security: &a23
        - oauth2:
            - controlplane_admin
            - controlplane_dataplane
  /api/management/transfers/{processId}:
    get:
      operationId: TransferManagementController_getTransfer
      summary: Get transfer details by process ID
      parameters:
        - name: processId
          required: true
          in: path
          description: Process ID
          schema:
            type: string
      responses:
        "200":
          description: ""
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/TransferDetailSchema"
      tags: *a22
      security: *a23
  /api/management/transfers/request:
    post:
      operationId: TransferManagementController_requestTransfer
      summary: Request a new transfer
      parameters:
        - name: address
          required: true
          in: query
          description: Control plane address
          schema:
            type: string
        - name: agreementId
          required: true
          in: query
          description: Agreement ID
          schema:
            type: string
        - name: format
          required: true
          in: query
          description: Format
          schema:
            type: string
        - name: audience
          required: true
          in: query
          description: Audience
          schema:
            type: string
      responses:
        default:
          description: ""
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/TransferProcessSchema"
      tags: *a22
      security: *a23
  /api/management/transfers/{processId}/start:
    post:
      operationId: TransferManagementController_startTransfer
      summary: Start a transfer process
      parameters:
        - name: processId
          required: true
          in: path
          description: Process ID
          schema:
            type: string
      requestBody:
        required: false
        content:
          application/json:
            schema:
              $ref: "#/components/schemas/DataPlaneAddressSchema"
      responses:
        "200":
          description: Transfer started successfully
          content:
            application/json:
              schema:
                example:
                  status: success
      tags: *a22
      security: *a23
  /api/management/transfers/{processId}/complete:
    post:
      operationId: TransferManagementController_completeTransfer
      summary: Complete a transfer process
      parameters:
        - name: processId
          required: true
          in: path
          description: Process ID
          schema:
            type: string
      responses:
        "200":
          description: Transfer completed successfully
          content:
            application/json:
              schema:
                example:
                  status: success
      tags: *a22
      security: *a23
  /api/management/transfers/{processId}/terminate:
    post:
      operationId: TransferManagementController_terminateTransfer
      summary: Terminate a transfer process
      parameters:
        - name: processId
          required: true
          in: path
          description: Process ID
          schema:
            type: string
      requestBody:
        required: true
        content:
          application/json:
            schema:
              example:
                code: TERMINATION_CODE
                reason: Reason for termination
      responses:
        "200":
          description: Transfer terminated successfully
          content:
            application/json:
              schema:
                example:
                  status: success
      tags: *a22
      security: *a23
  /api/management/transfers/{processId}/suspend:
    post:
      operationId: TransferManagementController_suspendTransfer
      summary: Suspend a transfer process
      parameters:
        - name: processId
          required: true
          in: path
          description: Process ID
          schema:
            type: string
      requestBody:
        required: true
        content:
          application/json:
            schema:
              example:
                reason: Reason for suspension
      responses:
        "200":
          description: Transfer suspended successfully
          content:
            application/json:
              schema:
                example:
                  status: success
      tags: *a22
      security: *a23
  /api/management/registry:
    get:
      operationId: RegistryClientController_requestCatalogs
      summary: Request catalogs
      description: Requests all available catalogs.
      parameters: []
      responses:
        "200":
          description: ""
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/CatalogSchema"
        "403":
          description: Forbidden
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ErrorDto"
      tags: &a24
        - Registry Management
      security: &a25
        - oauth2:
            - controlplane_admin
            - controlplane_dataplane
  /api/management/registry/addresses:
    get:
      operationId: RegistryClientController_requestAddresses
      summary: Request addresses
      description: Requests all available credential addresses.
      parameters: []
      responses:
        "200":
          description: ""
          content:
            application/json:
              schema:
                type: array
                items:
                  $ref: "#/components/schemas/CredentialAddressDto"
        "403":
          description: Forbidden
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ErrorDto"
      tags: *a24
      security: *a25
  /api/management/registry/didDocuments:
    get:
      operationId: RegistryClientController_requestDIDDocuments
      summary: Request DID Documents
      description:
        Requests all DID Documents that could be retrieved at the Wallet
        this Control Plane is linked to.
      parameters: []
      responses:
        "200":
          description: ""
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/DIDDocumentDto"
        "403":
          description: Forbidden
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ErrorDto"
      tags: *a24
      security: *a25
  /api/management/registry/catalogs:
    get:
      operationId: RegistryClientController_getCatalogs
      summary: Get catalogs
      description: Fetches all catalogs from the registry.
      parameters: []
      responses:
        "200":
          description: ""
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/CatalogSchema"
        "403":
          description: Forbidden
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ErrorDto"
      tags: *a24
      security: *a25
  /api/registry:
    get:
      operationId: RegistryController_getCatalogs
      summary: Get all catalogs
      parameters: []
      responses:
        "200":
          description: Successfully fetched all catalogs
          content:
            application/json:
              schema:
                type: array
                items:
                  $ref: "#/components/schemas/CatalogSchema"
      tags: &a26
        - Registry
      security: &a27
        - bearer: []
  /api/registry/addresses:
    get:
      operationId: RegistryController_requestAddresses
      summary: Request all addresses
      parameters: []
      responses:
        "200":
          description: Successfully fetched all addresses
          content:
            application/json:
              schema:
                type: array
                items:
                  $ref: "#/components/schemas/CredentialAddressDto"
      tags: *a26
      security: *a27
info:
  title: TSG Control Plane
  description: "This OpenAPI specification shows the endpoints of the Control
    Plane. Most of the endpoints are related to the Dataspace Protocol, as
    specified by the Eclipse Working Group Dataspaces. Other endpoints are
    supportive endpoints to make sure the data can be added to the catalog, and
    to make sure that UI interactions can take place.  __*Note*__: This OpenAPI
    definition is not intended to be directly linked with a single Control Plane
    instance. "
  version: 1.0.0
  contact: {}
  license:
    name: Apache 2.0
    url: https://www.apache.org/licenses/LICENSE-2.0.html
tags:
  - name: Health
    description: Health Controller
  - name: Settings
    description: Settings Controller
  - name: Authentication
    description: Authentication Controller
  - name: Data Plane
    description: Data Plane Management Controller
  - name: Data Plane Management
    description: Data Plane Management Controller
  - name: Catalog
    description: Catalog Controller
  - name: Catalog Management
    description: Catalog Management Controller
  - name: Negotiations
    description: Negotiations Controller
  - name: Negotiations Management
    description: Negotiations Management Controller
  - name: Transfers
    description: Transfers Controller
  - name: Transfers Management
    description: Transfers Management Controller
  - name: Registry
    description: Registry Controller
  - name: Registry Management
    description: Registry Management Controller
servers: []
components:
  securitySchemes:
    oauth2:
      type: oauth2
      flows:
        password:
          scopes:
            controlplane_admin: controlplane_admin
            controlplane_dataplane: controlplane_dataplane
    bearer:
      scheme: bearer
      bearerFormat: VP
      type: http
      description:
        Verifiable Presentation needed to communicate between two instances
        of the control plane.
  schemas:
    RuntimeConfigDto:
      type: object
      properties:
        controlPlaneInteractions:
          type: string
      required:
        - controlPlaneInteractions
    ErrorDto:
      type: object
      properties:
        name:
          type: string
        status:
          type: string
        code:
          type: number
        message:
          type: object
        error:
          type: string
      required:
        - name
        - status
        - code
    ClientInfoDto:
      type: object
      properties:
        sub:
          type: string
        name:
          type: string
        email:
          type: string
        roles:
          type: array
          items:
            type: string
      required:
        - sub
        - name
        - email
        - roles
    AuthenticatedUserDto:
      type: object
      properties:
        state:
          type: object
        user:
          $ref: "#/components/schemas/ClientInfoDto"
      required:
        - state
        - user
    UnauthenticatedUserDto:
      type: object
      properties:
        state:
          type: object
      required:
        - state
    DataPlaneCreationDto:
      type: object
      properties:
        datasets:
          type: array
          items:
            type: string
        dataplaneType:
          type: string
        endpointPrefix:
          type: string
        callbackAddress:
          type: string
        managementAddress:
          type: string
        managementToken:
          type: string
        catalogSynchronization:
          type: string
        role:
          type: string
        identifier:
          type: string
      required:
        - dataplaneType
        - endpointPrefix
        - callbackAddress
        - managementAddress
        - managementToken
        - catalogSynchronization
        - role
    DataPlaneDto:
      type: object
      properties:
        datasets:
          type: array
          items:
            type: string
        dataplaneType:
          type: string
        endpointPrefix:
          type: string
        callbackAddress:
          type: string
        managementAddress:
          type: string
        managementToken:
          type: string
        catalogSynchronization:
          type: string
        role:
          type: string
        identifier:
          type: string
      required:
        - dataplaneType
        - endpointPrefix
        - callbackAddress
        - managementAddress
        - managementToken
        - catalogSynchronization
        - role
        - identifier
    ConstraintSchema:
      type: object
      properties:
        "@type":
          type: string
        odrl:leftOperand:
          type: string
        odrl:operator:
          type: string
        odrl:rightOperand:
          type: object
        odrl:rightOperandReference:
          type: string
      required:
        - "@type"
        - odrl:leftOperand
        - odrl:operator
    PermissionSchema:
      type: object
      properties:
        "@type":
          type: string
        odrl:assigner:
          type: string
        odrl:assignee:
          type: string
        odrl:action:
          type: string
        odrl:target:
          type: string
        odrl:constraint:
          type: array
          items:
            $ref: "#/components/schemas/ConstraintSchema"
        odrl:Duty:
          type: array
          items:
            type: string
      required:
        - "@type"
        - odrl:action
    ProhibitionSchema:
      type: object
      properties:
        "@type":
          type: string
        odrl:assigner:
          type: string
        odrl:assignee:
          type: string
        odrl:action:
          type: string
        odrl:target:
          type: string
        odrl:constraint:
          type: array
          items:
            $ref: "#/components/schemas/ConstraintSchema"
      required:
        - "@type"
        - odrl:action
    Duty:
      type: object
      properties: {}
    PolicySchema:
      type: object
      properties:
        "@id":
          type: string
        "@type":
          type: string
        odrl:assigner:
          type: string
        odrl:assignee:
          type: string
        odrl:profile:
          type: string
        odrl:permission:
          type: array
          items:
            $ref: "#/components/schemas/PermissionSchema"
        odrl:prohibition:
          type: array
          items:
            $ref: "#/components/schemas/ProhibitionSchema"
        odrl:obligation:
          type: array
          items:
            $ref: "#/components/schemas/Duty"
        odrl:target:
          type: string
      required:
        - "@id"
        - "@type"
    DurationSchema:
      type: object
      properties:
        "@value":
          type: string
        "@type":
          type: string
      required:
        - "@value"
        - "@type"
    DatasetSchema:
      type: object
      properties:
        "@id":
          type: string
        dcat:contactPoint:
          type: string
        dcat:keyword:
          type: array
          items:
            type: string
        dcat:landingPage:
          type: string
        dcat:theme:
          type: array
          items:
            type: string
        dcat:conformsTo:
          type: string
        dct:creator:
          type: string
        dct:description:
          type: array
          items:
            type: string
        dct:identifier:
          type: string
        dct:isReferencedBy:
          type: string
        dct:issued:
          type: string
        dct:language:
          type: string
        dct:license:
          type: string
        dct:modified:
          type: string
        dct:publisher:
          type: string
        dct:relation:
          type: string
        dct:title:
          type: string
        dct:type:
          type: string
        odrl:hasPolicy:
          type: array
          items:
            $ref: "#/components/schemas/PolicySchema"
        dcat:hasVersion:
          type: array
          items:
            type: string
        dcat:isVersionOf:
          type: string
        dcat:version:
          type: string
        dcat:hasCurrentVersion:
          type: string
        dcat:previousVersion:
          type: string
        "@type":
          type: string
        dcat:distribution:
          type: array
          items:
            type: string
        dcat:spatialResolutionInMeters:
          type: string
        dcat:temporalResolution:
          $ref: "#/components/schemas/DurationSchema"
        dct:accrualPeriodicity:
          type: string
        dct:spatial:
          type: string
        dct:temporal:
          type: string
        prov:wasGeneratedBy:
          type: string
      required:
        - "@id"
        - "@type"
    ResourceSchema:
      type: object
      properties:
        "@id":
          type: string
        "@type":
          type: string
        dcat:contactPoint:
          type: string
        dcat:keyword:
          type: array
          items:
            type: string
        dcat:landingPage:
          type: string
        dcat:theme:
          type: array
          items:
            type: string
        dcat:conformsTo:
          type: string
        dct:creator:
          type: string
        dct:description:
          type: array
          items:
            type: string
        dct:identifier:
          type: string
        dct:isReferencedBy:
          type: string
        dct:issued:
          type: string
        dct:language:
          type: string
        dct:license:
          type: string
        dct:modified:
          type: string
        dct:publisher:
          type: string
        dct:relation:
          type: string
        dct:title:
          type: string
        dct:type:
          type: string
        odrl:hasPolicy:
          type: array
          items:
            $ref: "#/components/schemas/PolicySchema"
        dcat:hasVersion:
          type: array
          items:
            type: string
        dcat:isVersionOf:
          type: string
        dcat:version:
          type: string
        dcat:hasCurrentVersion:
          type: string
        dcat:previousVersion:
          type: string
      required:
        - "@id"
        - "@type"
    CatalogRecordSchema:
      type: object
      properties:
        "@id":
          type: string
        "@type":
          type: string
        dct:conformsTo:
          type: array
          items:
            type: string
        dct:description:
          type: array
          items:
            type: string
        dct:issued:
          format: date-time
          type: string
        dct:modified:
          format: date-time
          type: string
        dct:title:
          type: string
        foaf:primaryTopic:
          $ref: "#/components/schemas/ResourceSchema"
      required:
        - "@id"
        - "@type"
    DataServiceSchema:
      type: object
      properties:
        "@id":
          type: string
        dcat:contactPoint:
          type: string
        dcat:keyword:
          type: array
          items:
            type: string
        dcat:landingPage:
          type: string
        dcat:theme:
          type: array
          items:
            type: string
        dcat:conformsTo:
          type: string
        dct:creator:
          type: string
        dct:description:
          type: array
          items:
            type: string
        dct:identifier:
          type: string
        dct:isReferencedBy:
          type: string
        dct:issued:
          type: string
        dct:language:
          type: string
        dct:license:
          type: string
        dct:modified:
          type: string
        dct:publisher:
          type: string
        dct:relation:
          type: string
        dct:title:
          type: string
        dct:type:
          type: string
        odrl:hasPolicy:
          type: array
          items:
            $ref: "#/components/schemas/PolicySchema"
        dcat:hasVersion:
          type: array
          items:
            type: string
        dcat:isVersionOf:
          type: string
        dcat:version:
          type: string
        dcat:hasCurrentVersion:
          type: string
        dcat:previousVersion:
          type: string
        "@type":
          type: string
        dcat:endpointDescription:
          type: string
        dcat:endpointURL:
          type: string
        dcat:servesDataset:
          type: array
          items:
            $ref: "#/components/schemas/DatasetSchema"
      required:
        - "@id"
        - "@type"
    CatalogSchema:
      type: object
      properties:
        "@id":
          type: string
        dcat:contactPoint:
          type: string
        dcat:keyword:
          type: array
          items:
            type: string
        dcat:landingPage:
          type: string
        dcat:theme:
          type: array
          items:
            type: string
        dcat:conformsTo:
          type: string
        dct:creator:
          type: string
        dct:description:
          type: array
          items:
            type: string
        dct:identifier:
          type: string
        dct:isReferencedBy:
          type: string
        dct:issued:
          type: string
        dct:language:
          type: string
        dct:license:
          type: string
        dct:modified:
          type: string
        dct:publisher:
          type: string
        dct:relation:
          type: string
        dct:title:
          type: string
        dct:type:
          type: string
        odrl:hasPolicy:
          type: array
          items:
            $ref: "#/components/schemas/PolicySchema"
        dcat:hasVersion:
          type: array
          items:
            type: string
        dcat:isVersionOf:
          type: string
        dcat:version:
          type: string
        dcat:hasCurrentVersion:
          type: string
        dcat:previousVersion:
          type: string
        dcat:distribution:
          type: array
          items:
            type: string
        dcat:spatialResolutionInMeters:
          type: string
        dcat:temporalResolution:
          $ref: "#/components/schemas/DurationSchema"
        dct:accrualPeriodicity:
          type: string
        dct:spatial:
          type: string
        dct:temporal:
          type: string
        prov:wasGeneratedBy:
          type: string
        "@type":
          type: string
        dcat:dataset:
          type: array
          items:
            $ref: "#/components/schemas/DatasetSchema"
        dcat:record:
          type: array
          items:
            $ref: "#/components/schemas/CatalogRecordSchema"
        dcat:service:
          type: array
          items:
            $ref: "#/components/schemas/DataServiceSchema"
        dcat:themeTaxonomy:
          type: string
        dct:hasPart:
          type: array
          items:
            $ref: "#/components/schemas/ResourceSchema"
        foaf:homepage:
          type: string
      required:
        - "@id"
        - "@type"
    CatalogRequestMessageSchema:
      type: object
      properties:
        "@type":
          type: string
        dspace:filter:
          type: array
          items:
            type: string
      required:
        - "@type"
    OfferSchema:
      type: object
      properties:
        "@id":
          type: string
        "@type":
          type: string
        odrl:assigner:
          type: string
        odrl:assignee:
          type: string
        odrl:profile:
          type: string
        odrl:permission:
          type: array
          items:
            $ref: "#/components/schemas/PermissionSchema"
        odrl:prohibition:
          type: array
          items:
            $ref: "#/components/schemas/ProhibitionSchema"
        odrl:obligation:
          type: array
          items:
            $ref: "#/components/schemas/Duty"
        odrl:target:
          type: string
      required:
        - "@id"
        - "@type"
    ContractRequestMessageSchema:
      type: object
      properties:
        "@type":
          type: string
        dspace:consumerPid:
          type: string
        dspace:providerPid:
          type: string
        dspace:callbackAddress:
          type: string
        dspace:offer:
          $ref: "#/components/schemas/OfferSchema"
      required:
        - "@type"
        - dspace:consumerPid
        - dspace:callbackAddress
        - dspace:offer
    ContractNegotiationSchema:
      type: object
      properties:
        "@id":
          type: string
        "@type":
          type: string
        dspace:consumerPid:
          type: string
        dspace:providerPid:
          type: string
        dspace:state:
          type: string
      required:
        - "@id"
        - "@type"
        - dspace:consumerPid
        - dspace:providerPid
        - dspace:state
    ContractNegotiationEventMessageSchema:
      type: object
      properties:
        "@type":
          type: string
        dspace:consumerPid:
          type: string
        dspace:providerPid:
          type: string
        dspace:eventType:
          type: string
      required:
        - "@type"
        - dspace:consumerPid
        - dspace:providerPid
        - dspace:eventType
    ContractAgreementVerificationMessageSchema:
      type: object
      properties:
        "@type":
          type: string
        dspace:consumerPid:
          type: string
        dspace:providerPid:
          type: string
        dspace:hashedMessage:
          type: object
      required:
        - "@type"
        - dspace:consumerPid
        - dspace:providerPid
        - dspace:hashedMessage
    MultilanguageSchema:
      type: object
      properties:
        "@value":
          type: string
        "@language":
          type: string
      required:
        - "@value"
        - "@language"
    ContractNegotiationTerminationMessageSchema:
      type: object
      properties:
        "@type":
          type: string
        dspace:consumerPid:
          type: string
        dspace:providerPid:
          type: string
        dspace:code:
          type: string
        dspace:reason:
          type: array
          items:
            $ref: "#/components/schemas/MultilanguageSchema"
      required:
        - "@type"
        - dspace:consumerPid
        - dspace:providerPid
        - dspace:reason
    ContractOfferMessageSchema:
      type: object
      properties:
        "@type":
          type: string
        dspace:consumerPid:
          type: string
        dspace:providerPid:
          type: string
        dspace:offer:
          $ref: "#/components/schemas/OfferSchema"
        dspace:callbackAddress:
          type: string
      required:
        - "@type"
        - dspace:providerPid
        - dspace:offer
        - dspace:callbackAddress
    AgreementSchema:
      type: object
      properties:
        "@id":
          type: string
        "@type":
          type: string
        odrl:assigner:
          type: string
        odrl:assignee:
          type: string
        odrl:profile:
          type: string
        odrl:permission:
          type: array
          items:
            $ref: "#/components/schemas/PermissionSchema"
        odrl:prohibition:
          type: array
          items:
            $ref: "#/components/schemas/ProhibitionSchema"
        odrl:obligation:
          type: array
          items:
            $ref: "#/components/schemas/Duty"
        odrl:target:
          type: string
        dspace:timestamp:
          type: string
      required:
        - "@id"
        - "@type"
        - dspace:timestamp
    ContractAgreementMessageSchema:
      type: object
      properties:
        "@type":
          type: string
        dspace:consumerPid:
          type: string
        dspace:providerPid:
          type: string
        dspace:agreement:
          $ref: "#/components/schemas/AgreementSchema"
      required:
        - "@type"
        - dspace:consumerPid
        - dspace:providerPid
        - dspace:agreement
    NegotiationStatusDto:
      type: object
      properties:
        localId:
          type: string
        remoteId:
          type: string
        remoteParty:
          type: string
        role:
          type: string
        remoteAddress:
          type: string
        state:
          type: string
        dataSet:
          type: string
        modifiedDate:
          format: date-time
          type: string
      required:
        - localId
        - remoteId
        - remoteParty
        - role
        - remoteAddress
        - state
        - dataSet
        - modifiedDate
    NegotiationProcessEventSchema:
      type: object
      properties:
        time:
          format: date-time
          type: string
        state:
          type: string
        localMessage:
          type: string
        code:
          type: string
        reason:
          type: array
          items:
            $ref: "#/components/schemas/MultilanguageSchema"
        agreementMessage:
          type: string
        verification:
          $ref: "#/components/schemas/ContractAgreementVerificationMessageSchema"
        type:
          type: string
      required:
        - time
        - state
        - type
    NegotiationDetailSchema:
      type: object
      properties:
        localId:
          type: string
        remoteId:
          type: string
        remoteParty:
          type: string
        role:
          type: string
        remoteAddress:
          type: string
        state:
          type: string
        dataSet:
          type: string
        modifiedDate:
          format: date-time
          type: string
        offer:
          $ref: "#/components/schemas/OfferSchema"
        agreement:
          $ref: "#/components/schemas/AgreementSchema"
        events:
          type: array
          items:
            $ref: "#/components/schemas/NegotiationProcessEventSchema"
      required:
        - localId
        - remoteId
        - remoteParty
        - role
        - remoteAddress
        - state
        - dataSet
        - modifiedDate
        - offer
        - agreement
        - events
    VerifiableCredential:
      type: object
      properties: {}
    EvaluationContext:
      type: object
      properties:
        transferId:
          type: string
        localParticipant:
          type: string
        remoteParticipant:
          type: string
        target:
          type: string
        action:
          type: string
        verifiableCredentials:
          $ref: "#/components/schemas/VerifiableCredential"
        evaluationTime:
          format: date-time
          type: string
      required:
        - localParticipant
        - remoteParticipant
        - target
        - action
        - verifiableCredentials
        - evaluationTime
    EvaluationDecision:
      type: object
      properties:
        decision:
          type: string
        reason:
          type: string
        permissions:
          type: array
          items:
            type: string
        prohibitions:
          type: array
          items:
            type: string
        obligations:
          type: array
          items:
            type: string
        context:
          $ref: "#/components/schemas/EvaluationContext"
      required:
        - decision
    ConstraintType:
      type: string
      enum:
        - ATOMIC
        - LOGICAL
    ConstraintModel:
      type: object
      properties:
        id:
          type: number
        type:
          $ref: "#/components/schemas/ConstraintType"
        title:
          type: string
        description:
          type: string
      required:
        - type
        - title
    RuleType:
      type: string
      enum:
        - PERMISSION
        - PROHIBITION
        - DUTY
    Rule:
      type: object
      properties:
        id:
          type: number
        action:
          type: array
          items:
            type: string
        assignee:
          type: array
          items:
            type: string
        constraints:
          type: array
          items:
            $ref: "#/components/schemas/ConstraintModel"
        duties:
          type: array
          items:
            $ref: "#/components/schemas/Rule"
        type:
          $ref: "#/components/schemas/RuleType"
        target:
          type: string
      required:
        - action
        - constraints
        - duties
    EndpointPropertySchema:
      type: object
      properties:
        "@type":
          type: string
        dspace:name:
          type: string
        dspace:value:
          type: string
      required:
        - "@type"
        - dspace:name
        - dspace:value
    DataAddressSchema:
      type: object
      properties:
        "@type":
          type: string
        dspace:endpointType:
          type: string
        dspace:endpoint:
          type: string
        dspace:endpointProperties:
          type: array
          items:
            $ref: "#/components/schemas/EndpointPropertySchema"
      required:
        - "@type"
        - dspace:endpointType
        - dspace:endpoint
        - dspace:endpointProperties
    TransferRequestMessageSchema:
      type: object
      properties:
        "@type":
          type: string
        dspace:consumerPid:
          type: string
        dspace:agreementId:
          type: string
        dct:format:
          type: string
        dspace:dataAddress:
          $ref: "#/components/schemas/DataAddressSchema"
        dspace:callbackAddress:
          type: string
      required:
        - "@type"
        - dspace:consumerPid
        - dspace:agreementId
        - dct:format
        - dspace:callbackAddress
    TransferProcessSchema:
      type: object
      properties:
        "@type":
          type: string
        dspace:providerPid:
          type: string
        dspace:consumerPid:
          type: string
        dspace:agreementId:
          type: string
        dspace:state:
          type: string
      required:
        - "@type"
        - dspace:providerPid
        - dspace:consumerPid
        - dspace:agreementId
        - dspace:state
    TransferStartMessageSchema:
      type: object
      properties:
        "@type":
          type: string
        dspace:providerPid:
          type: string
        dspace:consumerPid:
          type: string
        dspace:dataAddress:
          $ref: "#/components/schemas/DataAddressSchema"
      required:
        - "@type"
        - dspace:providerPid
        - dspace:consumerPid
    TransferCompletionMessageSchema:
      type: object
      properties:
        "@type":
          type: string
        dspace:providerPid:
          type: string
        dspace:consumerPid:
          type: string
      required:
        - "@type"
        - dspace:providerPid
        - dspace:consumerPid
    TransferTerminationMessageSchema:
      type: object
      properties:
        "@type":
          type: string
        dspace:providerPid:
          type: string
        dspace:consumerPid:
          type: string
        dspace:code:
          type: string
        dspace:reason:
          type: array
          items:
            type: string
      required:
        - "@type"
        - dspace:providerPid
        - dspace:consumerPid
        - dspace:code
        - dspace:reason
    TransferSuspensionMessageSchema:
      type: object
      properties:
        "@type":
          type: string
        dspace:providerPid:
          type: string
        dspace:consumerPid:
          type: string
        dspace:reason:
          type: array
          items:
            type: string
      required:
        - "@type"
        - dspace:providerPid
        - dspace:consumerPid
        - dspace:reason
    TransferStatusDto:
      type: object
      properties:
        localId:
          type: string
        remoteId:
          type: string
        role:
          type: string
        remoteAddress:
          type: string
        remoteParty:
          type: string
        state:
          type: string
        process:
          $ref: "#/components/schemas/TransferProcessSchema"
        agreementId:
          type: string
        format:
          type: string
        modifiedDate:
          format: date-time
          type: string
      required:
        - localId
        - role
        - remoteAddress
        - remoteParty
        - state
        - process
        - agreementId
        - modifiedDate
    DataPlaneTransferSchema:
      type: object
      properties:
        accepted:
          type: boolean
        identifier:
          type: string
        dataAddress:
          $ref: "#/components/schemas/DataAddressSchema"
        callbackAddress:
          type: string
        dataPlaneIdentifier:
          type: string
        endpointType:
          type: string
      required:
        - accepted
        - identifier
        - dataPlaneIdentifier
        - endpointType
    TransferEventSchema:
      type: object
      properties:
        time:
          format: date-time
          type: string
        state:
          type: string
        localMessage:
          type: string
        code:
          type: string
        reason:
          $ref: "#/components/schemas/MultilanguageSchema"
        type:
          type: string
      required:
        - time
        - state
        - localMessage
        - code
        - type
    TransferDetailSchema:
      type: object
      properties:
        localId:
          type: string
        remoteId:
          type: string
        role:
          type: string
        remoteAddress:
          type: string
        remoteParty:
          type: string
        state:
          type: string
        process:
          $ref: "#/components/schemas/TransferProcessSchema"
        agreementId:
          type: string
        format:
          type: string
        modifiedDate:
          format: date-time
          type: string
        dataAddress:
          $ref: "#/components/schemas/DataAddressSchema"
        dataPlaneTransfer:
          $ref: "#/components/schemas/DataPlaneTransferSchema"
        events:
          $ref: "#/components/schemas/TransferEventSchema"
      required:
        - localId
        - role
        - remoteAddress
        - remoteParty
        - state
        - process
        - agreementId
        - modifiedDate
        - dataAddress
        - dataPlaneTransfer
        - events
    DataPlaneAddressSchema:
      type: object
      properties:
        endpoint:
          type: string
        properties:
          type: array
          items:
            type: string
      required:
        - endpoint
        - properties
    CredentialAddressDto:
      type: object
      properties:
        didId:
          type: string
        address:
          type: string
      required:
        - didId
        - address
    JsonWebKeyDto:
      type: object
      properties:
        alg:
          type: string
        crv:
          type: string
        e:
          type: string
        ext:
          type: boolean
        key_ops:
          type: array
          items:
            type: string
        kid:
          type: string
        kty:
          type: string
        n:
          type: string
        use:
          type: string
        x:
          type: string
        y:
          type: string
      required:
        - kty
    VerificationMethodDto:
      type: object
      properties:
        id:
          type: string
        type:
          type: string
        controller:
          type: string
        publicKeyJwk:
          $ref: "#/components/schemas/JsonWebKeyDto"
      required:
        - id
        - type
        - controller
    ServiceDto:
      type: object
      properties:
        id:
          type: string
        type:
          type: string
        serviceEndpoint:
          oneOf:
            - &a28
              type: string
            - type: array
              items: *a28
      required:
        - id
        - type
        - serviceEndpoint
    DIDDocumentDto:
      type: object
      properties:
        "@context":
          oneOf:
            - &a29
              type: string
            - type: array
              items: *a29
        id:
          type: string
        alsoKnownAs:
          type: array
          items:
            type: string
        controller:
          oneOf:
            - &a30
              type: string
            - type: array
              items: *a30
        verificationMethod:
          type: array
          items:
            $ref: "#/components/schemas/VerificationMethodDto"
        service:
          type: array
          items:
            $ref: "#/components/schemas/ServiceDto"
        publicKey:
          type: array
          items:
            $ref: "#/components/schemas/VerificationMethodDto"
        authentication:
          type: array
          items:
            oneOf:
              - type: string
              - $ref: "#/components/schemas/VerificationMethodDto"
        assertionMethod:
          type: array
          items:
            oneOf:
              - type: string
              - $ref: "#/components/schemas/VerificationMethodDto"
        keyAgreement:
          type: array
          items:
            oneOf:
              - type: string
              - $ref: "#/components/schemas/VerificationMethodDto"
        capabilityInvocation:
          type: array
          items:
            oneOf:
              - type: string
              - $ref: "#/components/schemas/VerificationMethodDto"
        capabilityDelegation:
          type: array
          items:
            oneOf:
              - type: string
              - $ref: "#/components/schemas/VerificationMethodDto"
      required:
        - id
externalDocs:
  description: Git Repository
  url: https://gitlab.com/tno-tsg/dataspace-protocol/tno-security-gateway
